diff --git a/drivers/pci.c b/drivers/pci.c
index 672dcd0..00551bf 100644
--- a/drivers/pci.c
+++ b/drivers/pci.c
@@ -1605,8 +1605,10 @@ static phandle_t ob_configure_pci_device(const char* parent_path,
         const pci_dev_t *pci_dev;
     uint8_t class, subclass, iface;
     int num_bars, rom_bar;
+    char args[32];
 
     phandle_t phandle = 0;
+    ihandle_t ihandle = 0, save_ihandle = 0;
     int is_host_bridge = 0;
 
     if (!ob_pci_read_identification(bus, devnum, fn, &vid, &did, &class, &subclass)) {
@@ -1709,6 +1711,22 @@ static phandle_t ob_configure_pci_device(const char* parent_path,
     /* device is configured so we may move it out of scope */
     device_end();
 
+    /* set arguments */
+    save_ihandle = my_self();
+
+    ihandle = open_dev(config.path);
+    PUSH(ihandle);
+    feval("to my-self");
+
+    PUSH(0);
+    PUSH(0);
+    snprintf(args, sizeof(args), "%x,%x", devnum, fn);
+    push_str(args);
+    fword("set-args");
+
+    PUSH(save_ihandle);
+    feval("to my-self");
+
     /* scan bus behind bridge device */
     //if (htype & PCI_HEADER_TYPE_BRIDGE && class == PCI_BASE_CLASS_BRIDGE) {
     if ( class == PCI_BASE_CLASS_BRIDGE &&
